int anzahlDerPersonen = 5000;
Person[] personen;
int personenRadius = 3;
float abstandNachZumOberenRand = 100;  //Dann habe ich Platz für Infos
int abgelaufeneTage;
int anzahlDerFramesProTag = 15;
int tageBisZurHeilung = 10; //14 wäre zu langsam
int infektionsradius = 20;
float uebertragungswahrscheinlichkeit = 0.8;
int anzahlDerInfizierten=0;
int anzahlDerGenesenen=0;
boolean zeigeInfektionsRadius = true;
boolean prozentDarstellung = false;

void setup() {
  //Init alle Daten
  personen = new Person[anzahlDerPersonen];
  for (int i=0; i<anzahlDerPersonen; i++) {
    personen[i] = new Person();
  }
  abgelaufeneTage = 0;
  
  //Bildschirm
  size(800,800);
  background(0);
  frameRate(30);
  noStroke();
  
  println("Tag"+"\t"+"Möglich"+"\t"+"Erkrankte"+"\t"+"Genesene");
  int personNull = int(random(anzahlDerPersonen));
  personen[personNull].zustand=1;
  personen[personNull].tageDerInfizierung = tageBisZurHeilung;
  anzahlDerInfizierten++;
}

void draw() {
  //------Spielhintergund und Infos
  background(0);
  
  //----------Personen anzeigen
  for (int i=0; i<anzahlDerPersonen; i++) {
    personen[i].update();
    personen[i].show();
  }
  
  //----------Tage aktualsieren
  //Wenn die Anzahl der frames geteilt durch anzahlDerFramesProTag den Rest 0 hat
  if (frameCount%anzahlDerFramesProTag==0) { 
    abgelaufeneTage++;     //Alle anzahlDerFramesProTag Frames ist ein Tag vorbei 
    println(abgelaufeneTage+"\t"+(anzahlDerPersonen-(anzahlDerInfizierten+anzahlDerGenesenen))+"\t"+anzahlDerInfizierten+"\t"+anzahlDerGenesenen);
    //Aktualisieren, wer geheilt wird
    for (int i=0; i<anzahlDerPersonen; i++) {
      if (personen[i].zustand==1) {
        personen[i].tageDerInfizierung--;
        if (personen[i].tageDerInfizierung==0) {
          personen[i].zustand=2;
          anzahlDerGenesenen++;
          anzahlDerInfizierten--;
        }
      }
    }
  }
  
  
  //Aktualisieren, wer erkrankt wird
  for (int i=0; i<anzahlDerPersonen; i++) {
    if (personen[i].zustand==1) {
      //---- Übertragen der Krankheit auf eine andere Person?
      for (int j=i+1; j<anzahlDerPersonen; j++) {
        //Prüfen, ob die Person j nah genug ist
        if (dist(personen[i].x,personen[i].y,personen[j].x,personen[j].y)<infektionsradius) {
          //Mit einer bestimmten Wahrscheinlichkeit wird übertragen 
          if (random(1)<uebertragungswahrscheinlichkeit && personen[j].zustand==0) {
            //Person j wird infiziert
            personen[j].zustand=1;
            personen[j].tageDerInfizierung = tageBisZurHeilung;
            anzahlDerInfizierten++;
          }
        }
      }
    }
  }
    
  zeigeInfos();
}

void mouseReleased() {
  personen[int(random(anzahlDerPersonen))].zustand=1;
}


void zeigeInfos() {
  fill(255);
  textSize(32);
  textAlign(CENTER);
  text("Virus-Simulation",width/2,50);
  
  textSize(18);
  textAlign(LEFT);
  text("Tag: "+abgelaufeneTage,20,25);
  textSize(12);
  text("Übertragung: "+(uebertragungswahrscheinlichkeit*100)+"%",20,50);
  text("Radius: "+infektionsradius,20,65);
  text("Tage bis zur Genesung: "+tageBisZurHeilung,20,80);
  
  textSize(18);
  textAlign(RIGHT);
  int verschiebung = 20;
  if (prozentDarstellung) {
    fill(255,0,0);
    text("Infizierte: "+anzahlDerInfizierten*100/anzahlDerPersonen+"%",width-verschiebung,25);
    fill(255,255,0);
    text("Genesene: "+anzahlDerGenesenen*100/anzahlDerPersonen+"%",width-verschiebung,55);
    fill(255);
    text("Kandidaten: "+(anzahlDerInfizierten+anzahlDerGenesenen)*100/anzahlDerPersonen+"%",width-verschiebung,85);
  } else {
    fill(255,0,0);
    text("Infizierte: "+anzahlDerInfizierten,width-verschiebung,25);
    fill(255,255,0);
    text("Genesene: "+anzahlDerGenesenen,width-verschiebung,55);
    fill(255);
    text("Kandidaten: "+(anzahlDerPersonen-(anzahlDerInfizierten+anzahlDerGenesenen)),width-verschiebung,85);
  }
}
